#!/usr/bin/env python

# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license. 
# Thank you for using free software!
#
#(c) QB89Dragon 2007/8 <hughescih@hotmail.com>
#(c) Whise 2008,2009 <helderfraga@gmail.com>
#
# Consolidated Gnome Menu
# This is free software made available under the GNU public license.
# Use 'run-in-window' command switch for development testing

import time # this is a workarround for unknown oafiid error !!! does it work???
import logging 


try:
	import gtk
except:
	time.sleep(5)
	import gtk
try:
	import pygtk
	pygtk.require('2.0')
except:
	time.sleep(5)
	import pygtk
	pygtk.require('2.0')
try:
	import commands
except:
	time.sleep(5)
	import commands
try:
	import sys
except:
	time.sleep(5)
	import sys
try:
	import gobject
except:
	time.sleep(5)
	import gobject
try:
	import gnomeapplet
except:
	time.sleep(5)
	import gnomeapplet
try:
	import pango
except:
	time.sleep(5)
	import pango
try:
	import os
except:
	time.sleep(5)
	import os

if not os.path.exists(os.path.expanduser("~") + '/.gnomenu') or not os.path.isdir(os.path.expanduser("~") + '/.gnomenu'):
	os.system('mkdir ~/.gnomenu')
LOG_FILENAME = os.path.expanduser("~") + '/.gnomenu/.GnoMenulog.txt'
logging.basicConfig(filename=LOG_FILENAME,level=logging.DEBUG,)

logging.debug('0 - ' + str(commands.getoutput('date')))
logging.debug('1 - logging started')

logging.debug('Importing gconf')
try:
	import gconf
except:
	time.sleep(5)
	import gconf
logging.debug('Importing cairo')
try:
	import cairo
except:
	time.sleep(5)
	import cairo
logging.debug('2')

try:
	INSTALL_PREFIX = open("/etc/gnomenu/prefix").read()[:-1] 
except:
	INSTALL_PREFIX = '/usr'

#sys.path.append(INSTALL_PREFIX + '/lib/gnomenu/') #is this causing the oafiid error???

logging.debug('Importing Globals')
try:
	import Globals
except:
	time.sleep(5)
	import Globals

logging.debug('Importing backend')

try:
	import backend
except:
	time.sleep(5)
	import backend

logging.debug('Importing Main_Menu')
try:
	from Menu_Main import Main_Menu
except:
	time.sleep(5)
	from Menu_Main import Main_Menu

logging.debug('Importing utils')
try:
	import utils
except:
	time.sleep(5)
	import utils

logging.debug('Importing gettext')
try:
	import gettext
except:
	time.sleep(5)
	import gettext

logging.debug('2 - imports finished')

gettext.textdomain('gnomenu')
gettext.install('gnomenu', INSTALL_PREFIX +  '/share/locale')
gettext.bindtextdomain('gnomenu', INSTALL_PREFIX +  '/share/locale')


logging.debug('3 - translations loaded')

def _(s):
	return gettext.gettext(s)

class GnoMenu(gnomeapplet.Applet):
	global Button_state
	def __init__(self,applet,iid):
		

		logging.debug('6 - Applet started loading')

		self.timeout_interval = 200
		self.panel_size = 24
		self.Button_state = 0 # 0 = No change  1 = Mouse over  2 = Depressed
		self.tooltip_text = "Consolidated menu for the Gnome desktop"
		self.applet = applet
		self.applet.set_name("GnoMenu")
		self.remove_applet_border()
		self.panel_id = None
		self.hwg = None
		orient = None
		try:
			orient = self.applet.get_orient()
		except:pass

		self.orientation = None
		if orient == 1:
			self.orientation = 'top'
		else:
			self.orientation = 'bottom'

		self.gconf_client = gconf.client_get_default()
		self.gconfkey = self.applet.get_preferences_key()
		

		#### Get panel applet id, size, position, orientation and others#####
		#####################################################################

		if self.orientation == 'top':
			Globals.flip = False
		elif self.orientation == 'bottom':
			Globals.flip = None
		else : self.size = 30



		self.size = self.get_panel_size()
		self.store_settings()
		print self.size
		#print Globals.DefaultSettings['SuperL']
		######Create all the necessary get widgets in the panel##############
		#####################################################################

		self.Main_icon_box = gtk.Fixed()
		self.ev_box = gtk.EventBox()
		self.Main_icon_box.put(self.ev_box,0,0)
		self.applet.add(self.Main_icon_box)
		self.ev_box.set_border_width(0)
		self.ev_box.set_visible_window(0)
		self.Main_icon_box.set_border_width(0)
		self.size = self.get_panel_size()
		self.image_icon = gtk.Image()				
		im = cairo.ImageSurface.create_from_png(Globals.StartButton[self.Button_state])
		w = im.get_width()
		h = im.get_height()
		im = None

		self.scale = float(self.size)/float(h)
		if Globals.ButtonLabelCount == 1:
			self.set_button_label()

		pixmap = gtk.gdk.pixbuf_new_from_file_at_size(Globals.StartButton[self.Button_state],int(w*self.scale),int(self.size))

		if Globals.flip == False and Globals.ButtonHasTop == 1:
			pixmap = pixmap.flip(Globals.flip)

		self.image_icon.set_from_pixbuf(pixmap)

		self.ev_box.add(self.image_icon)
		
		self.applet.set_background_widget(self.applet)
		self.applet.connect("destroy",self.cleanup)
	        self.applet.connect("destroy-event",self.cleanup)
	        self.applet.connect("delete-event",self.cleanup)
	        self.applet.connect("change-orient",self.change_orientation)
      		self.applet.connect("size-allocate", self.size_allocate_event)
		self.ev_box.connect("button-press-event",self.button_press)
		self.ev_box.connect("enter-notify-event", self.select_box)
		self.ev_box.connect("leave-notify-event", self.deselect_box)




		#####Show welcome screen on first run Launch the welcome screen#######
		######################################################################

		if Globals.FirstUse:
			os.system("/bin/sh -c " + INSTALL_PREFIX +"'/lib/"+Globals.appdirname+"/GnoMenu-Settings.py --welcome' &")


		self.old_origin = None
		self.oldsize = 0
		self.x,self.y = 0,0
		self.oldx,self.oldy = 0,0
		self.aux = None
		self.applet.show_all()
		self.callback = gobject.timeout_add(1000,self.timeout_callback)
		self.ev_box.set_size_request(-1,self.size )
		self.Main_icon_box.set_size_request(-1,self.size )
		self.image_icon.set_size_request(-1,self.size)

		logging.debug('7 - Applet init end')


	def store_settings(self):
		"""Stores orientation in settings"""
		if self.orientation != backend.load_setting("orientation"):
			if self.orientation == None:
				backend.save_setting('orientation', 'bottom')
				backend.save_setting('size', self.size)
			else:
				utils.show_message(_('Menu needs to restart , restart now?'))
				backend.save_setting('orientation', self.orientation)
				backend.save_setting('size', self.size)
				sys.exit()
		try:
			backend.save_setting('orientation', self.orientation)
			backend.save_setting('size', self.size)
		except:pass


	def get_panel_size(self):
		if self.gconfkey != None:
			self.gconfkey = str(self.gconfkey).replace('/prefs','')
			self.panel_id = self.gconf_client.get_string(self.gconfkey + "/toplevel_id")			

		if self.panel_id != None:				
			self.size = int(self.gconf_client.get_int("/apps/panel/toplevels/" + self.panel_id + "/size"))
			self.gconf_client.add_dir("/apps/panel/toplevels/" + self.panel_id + "/size",gconf.CLIENT_PRELOAD_NONE)
			self.gconf_client.notify_add("/apps/panel/toplevels/" + self.panel_id + "/size", self.update_panel_size) 
			return int(self.size)
		else: 

			try:
				self.size= self.applet.get_size()
			except:
				self.size = 30
			return self.size


	def set_button_label(self):
		self.Label = gtk.Label()
		self.txt = Globals.ButtonLabelMarkup
		try:
			self.txt = self.txt.replace(Globals.ButtonLabelName,_(Globals.ButtonLabelName))
		except:pass
		self.Main_icon_box.put(self.Label,int(self.scale*Globals.ButtonLabelX),int(self.scale*Globals.ButtonLabelY))
		self.set_button_label_size()

	def set_button_label_size(self):
		im = cairo.ImageSurface.create_from_png(Globals.StartButton[self.Button_state])
		w = im.get_width()
		h = im.get_height()
		im = None
		self.txt = Globals.ButtonLabelMarkup
		try:
			self.txt = self.txt.replace(Globals.ButtonLabelName,_(Globals.ButtonLabelName))
		except:pass
		self.scale = float(self.size)/float(h)
		self.Main_icon_box.move(self.Label,int(self.scale*Globals.ButtonLabelX),int(self.scale*Globals.ButtonLabelY))
		self.Label.set_size_request(-1,self.size)
		self.txt_font = self.txt[self.txt.find("font_desc='")+11:]
		self.txt_size = int(self.txt_font[:self.txt_font.find("'")].split(' ').pop())
		self.txt_all = self.txt_font.replace(str(self.txt_size),str(int(self.txt_size*self.scale)))
		self.txt = self.txt.replace(self.txt_font,self.txt_all)
		self.Label.set_markup(self.txt)	

	def remove_applet_border(self):
      		gtk.rc_parse_string ("""
	               style \"GnoMenu-style\"
	               {
	                 GtkWidget::focus-line-width = 0
	                 GtkWidget::focus-padding = 0
	               }
	               widget \"*.GnoMenu\" style \"GnoMenu-style\"
	               """)



	def change_orientation(self,arg1,data):
		orient = self.applet.get_orient()
		self.orientation = None
		if orient == 1:
			self.orientation = 'top'
		else:
			self.orientation = 'bottom'
		if self.orientation != backend.load_setting("orientation"):
			if self.orientation == None:
				backend.save_setting('orientation', 'bottom')
				backend.save_setting('size', self.size)
			else:
				utils.show_message(_('Menu needs to restart , restart now?'))
				backend.save_setting('orientation', self.orientation)
				backend.save_setting('size', self.size)
				sys.exit()
		

	def size_allocate_event(self, widget, allocation):
		if self.size != widget.allocation.height:
			if widget.allocation.height < 128: #weird bug giant button sometimes
				self.size = widget.allocation.height
				self.Redraw_graphics()
				self.Update_Panel_Top()
		if widget.window:		
			self.x, self.y = widget.window.get_origin()
			self.update_panel_position()
		else:
			self.x, self.y = 0,0		
		return True



	def update_panel_position(self):
		if self.x != self.oldx and self.hwg != None:
			print 'position changed'
			self.Redraw_graphics()
			self.Update_Panel_Top()
			if Globals.ShowTop == 1 and self.aux != None:
				self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])
			#self.hwg = Main_Menu(self.HideMenu)
			self.hwg.Adjust_Window_Dimensions(self.x,self.size)
			Globals.SavedOriginState = self.x,self.size
			self.oldx= self.x
			if Globals.ButtonLabelCount == 1:
				self.set_button_label_size()

	
	def update_panel_size(self,client, connection_id, entry, args):
		
		
		
		if entry.get_key() == "/apps/panel/toplevels/" + self.panel_id + "/size":
			try:
				self.size = entry.get_value().get_int()
			except:self.size = 30
		if self.size != self.oldsize and self.hwg :
			print 'size changed'
			self.Redraw_graphics()
			self.Update_Panel_Top()
			if Globals.ShowTop == 1 and self.aux != None:
				self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])
			#self.hwg = Main_Menu(self.HideMenu)
			self.hwg.Adjust_Window_Dimensions(self.x,self.size)
			Globals.SavedOriginState = self.x,self.size
			self.oldsize= self.size
			if Globals.ButtonLabelCount == 1:
				self.set_button_label_size()
					
		return True

	def auxdestroyed(self):	
		#Respawn point for the aux window if it has been Alt-F4ed
		if Globals.ShowTop == 1:
			#Used in this instance for providing delay for window to be created
			self.aux = PanelTopWindow()
			#self.aux.Create(self, 0)	 #Create the orb top
			self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])
				

	def button_press(self,widget,event):

		if event.button == 1:
			# Remove this next line when orb top repositioning on widget move is fixed
			if Globals.ShowTop == 1:
				pass
				#self.window_moved(self.aux)
			if self.Button_state == 2:
				self.HideMenu()
				self.Button_state = 1
			else:
				self.Button_state = 2
				self.Redraw_graphics()
				self.ShowMenu()
				
			self.Redraw_graphics()
			#self.Update_Panel_Top()
		elif event.button == 3:
			self.create_menu()
			
			
	def create_menu(self):

		self.propxml="""
		<popup name="button3">
		<menuitem name="Item 1" verb="Props" label="_Preferences..." pixtype="stock" pixname="gtk-properties"/>
		<menuitem name="Item 2" verb="About" label="_About..." pixtype="stock" pixname="gnome-stock-about"/>
		<menuitem name="Item 3" verb="Edit" label="_Edit Menus..." pixtype="stock" pixname="alacarte"/>
		</popup>
		"""
		self.verbs = [ ( "Props", self.properties ),
					   ( "About", self.about_info ),
					   ( "Edit", self.edit_menus) ]
		self.applet.setup_menu(self.propxml,self.verbs,None)
			
	def about_info(self,event,data=None):

		os.system("/bin/sh -c " + INSTALL_PREFIX +"'/lib/"+Globals.appdirname+"/GnoMenu-Settings.py --about' &")

	def properties(self,event,data=None):

		#os.spawnvp(os.P_WAIT,Globals.ProgramDirectory+"GnoMenu-Settings.py",[Globals.ProgramDirectory+"GnoMenu-Settings.py"])
		os.system("/bin/sh -c '"+Globals.ProgramDirectory+"GnoMenu-Settings.py' &")
		# Fixme, reload stuff properly
		Globals.ReloadSettings()
		
	def select_box(self,widget,event):
		if self.Button_state == 0:
			self.Button_state = 1
		self.Redraw_graphics()
		
	def deselect_box(self,widget,event):
		if self.Button_state == 1:
			self.Button_state = 0
		self.Redraw_graphics()
		
	def bindkey_callback(self,keybinding):
		print 'key'
		self.ToggleMenu()

	def bind_with_deskbar(self):
		path = str(commands.getoutput('locate _keybinder.so')).split('\n')[0]
		if path != '':
			x = commands.getoutput('xmodmap')
			if x.find('Super_L') == '-1' and Globals.Settings['Bind_Key'] == 'Super_L':
				os.system("xmodmap -e 'keycode 115 = Super_L'")
				os.system('xmodmap -e "add mod4 = Super_L"')
			path = path.replace('_keybinder.so','')
			sys.path.append(path)
			try:
				from _keybinder import tomboy_keybinder_bind as bindkey
				bindkey(Globals.Settings['Bind_Key'], self.ToggleMenu)			
				print 'deskbar found - binding'
			except:
				self.bind_with_custom()
		else:
			self.bind_with_custom()

				


	def bind_with_orca(self):
		print 'Trying to bind key using orca'
		x = commands.getoutput('xmodmap')
		if x.find('Super_L') == '-1' and Globals.Settings['Bind_Key'] == 'Super_L':
			os.system("xmodmap -e 'keycode 115 = Super_L'")
			os.system('xmodmap -e "add mod4 = Super_L"')
		#try:
		import orca.input_event
		import orca.keybindings
		import orca.settings
		import orca.orca
		myKeyBindings = orca.keybindings.KeyBindings()
		keyval, modifiers = gtk.accelerator_parse (Globals.Settings['Bind_Key'])
		sayTimeHandler = orca.input_event.InputEventHandler(  self.bindkey_callback,  "Presents the time.")

		#myKeyBindings.add(orca.keybindings.KeyBinding(Globals.Settings['Bind_Key'],modifiers,modifiers , sayTimeHandler))
		myKeyBindings.add(orca.keybindings.KeyBinding("F12",1 << orca.settings.MODIFIER_ORCA,1 << orca.settings.MODIFIER_ORCA,sayTimeHandler))
		#except:
		#	print 'Unable to bind the selected key'
		#	self.bind_with_custom()





	def bind_with_custom(self):
		print 'Using own key method - binding'
		x = commands.getoutput('xmodmap')
		if x.find('Super_L') == '-1' and Globals.Settings['Bind_Key'] == 'Super_L':
			os.system("xmodmap -e 'keycode 115 = Super_L'")
			os.system('xmodmap -e "add mod4 = Super_L"')
		try:
			from Xlib.display import Display
			from Xlib import X
			from globalkeybinding import GlobalKeyBinding
			gtk.gdk.threads_init ()
			keybinding = GlobalKeyBinding (Globals.Settings['Bind_Key'])
			keybinding.connect ('activate', self.bindkey_callback)
			keybinding.grab ()
			keybinding.start ()
		except:
			if Globals.FirstUse:
				utils.show_message('Please install python xlib')
			else:
				print 'Please install python xlib'


	def timeout_callback(self):

		if Globals.ShowTop == 1:
			#Create auxiliary window (CAIRO)
			from Panel_Top import PanelTopWindow
			self.aux = PanelTopWindow()
			self.aux.aux_window.connect("enter-notify-event", self.select_box)
			self.aux.aux_window.connect("leave-notify-event", self.deselect_box)
			self.aux.aux_window.connect("button-press-event",self.button_press)
		self.Redraw_graphics()
		self.Update_Panel_Top()
		if Globals.ShowTop == 1:
			self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])
		self.hwg = Main_Menu(self.HideMenu)
		self.hwg.Adjust_Window_Dimensions(self.x,self.size)
		Globals.SavedOriginState = self.x,self.size

		###### Hotkey Menu Activation ########################################
		######################################################################

		if Globals.Settings['SuperL'] == 1:
	                self.bind_with_deskbar()
		logging.debug('8 - Applet succesfully loaded')
		return False

		
	def cleanup(self,event):
		print "cleanup"

		self.hwg.destroy()
		if Globals.ShowTop == 1:
			Globals.ShowTop = 0
			self.aux.destroy()
		#os.system('rm ' +Globals.HomeDirectory + "/.menuiconcache.xml")
		#gtk.main_quit()
		del self.applet
	
	def edit_menus(self,event, data=None):
		os.spawnvp(os.P_WAIT,"alacarte",["alacarte"])#FIXME change this to use user input
		#ConstructMainMenu()

	def ToggleMenu(self):
		if self.Button_state == 2:
			self.Button_state = 0
			self.Redraw_graphics()
			self.HideMenu()
		else:
			self.Button_state = 2
			self.Redraw_graphics()
			self.ShowMenu()


	def ShowMenu(self):
		# Display the start menu!!!
		origin = self.applet.window.get_origin()
		try:
			if origin != Globals.SavedOriginState:
				self.hwg.Adjust_Window_Dimensions(origin[0],origin[1])
		except:pass
		while not hasattr(self,'hwg'):
			gtk.main_iteration()
		if self.hwg:
			self.hwg.show_window()

		#self.hwg.grab_focus()
	
	def HideMenu(self):
		if self.hwg:
			if self.hwg.window.window:
				if self.hwg.window.window.is_visible()== True:
					self.hwg.hide_window()

		self.Button_state = 0
		self.Redraw_graphics()

	def Redraw_graphics (self):
		self.Main_icon_box.set_size_request(-1,self.size)
		self.ev_box.set_size_request(-1,self.size)
		self.image_icon.set_size_request(-1,self.ev_box.allocation.height)
		im = cairo.ImageSurface.create_from_png(Globals.StartButton[self.Button_state])
		w = im.get_width()
		h = im.get_height()
		self.scale = float(self.size)/float(h)
		im = None
		pixmap = gtk.gdk.pixbuf_new_from_file(Globals.StartButton[self.Button_state]).scale_simple(int(w*self.scale),self.size,gtk.gdk.INTERP_HYPER)
		if Globals.flip == False and Globals.ButtonHasTop == 1:
			pixmap = pixmap.flip(Globals.flip)
			
		self.image_icon.set_from_pixbuf(pixmap)
		if Globals.ShowTop == 1 and self.aux != None:
			self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])

		pixmap = None

	def Update_Panel_Top(self,widget=None, event=None):

		if Globals.ShowTop == 1 and self.aux != None:
			self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])
			self.applet.queue_draw()
			self.aux.aux_window.window.set_transient_for(self.applet.window)
			if self.scale:
				self.aux.set_scale(self.scale)
			StartButtonTopHeight = self.aux.get_height()
			print "Reorientating Orb top!! (Don't let this happen too often!!)"
			Window_x =  self.x
			if self.orientation == 'top':
				Window_y =  0 + self.size
			else:
				Window_y =  Globals.screenheight - self.size - StartButtonTopHeight
			# Calculate midpoint of screen
			self.screenmidpty = int(Globals.screenheight / 2)
			# Work out orientation of panel 
			self.aux.move(Window_x,Window_y)
			self.old_size = self.size

try:
	gobject.type_register(GnoMenu)
except:pass

# Bonobo factory of Menu
def GnoMenu_factory(applet, iid):
	# Start the applet

	logging.debug('5 - Starting the applet')
	app = GnoMenu(applet,iid)
	return True

def showmenu(a):
	g.ToggleMenu()


if len(sys.argv) == 2:

	if sys.argv[1] == "--help":
		print "HELP============================================="
		print "Command:		 What it does:\n"
		print "run-in-window	 runs independant of gnome-panel"
		print "run-in-tray	 runs in system tray"
		print "================================================="
		sys.exit ()
	
	elif sys.argv[1] == "run-in-window" or sys.argv[1] == "run-in-console":
		# Start the applet in windowed mode
		main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		main_window.set_decorated(1)
		main_window.set_title("GnoMenu Testing Sandpit")
		main_window.connect("destroy", gtk.main_quit) 
		app = gnomeapplet.Applet()
		GnoMenu(app,"")
		app.reparent(main_window)
		main_window.show_all()
		gtk.main()
		sys.exit()
	
	elif sys.argv[1] == "run-in-tray":
		# Start the applet in tray mode
		tray = gtk.StatusIcon()
		pixbuf = gtk.gdk.pixbuf_new_from_file(INSTALL_PREFIX + "/lib/gnomenu/graphics/logo.png")
		tray.set_from_pixbuf(pixbuf)
		app = gnomeapplet.Applet()
		g = GnoMenu(app,"")
		tray.connect("activate", showmenu)
		main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		main_window.set_decorated(1)
		menu = gtk.Menu()
		x,y,z = gtk.status_icon_position_menu(menu, tray)
		main_window.move(x,y)
		#tray.connect("popup-menu", self.show_menu)
		#tray.set_tooltip("Screenlets daemon")
		tray.set_visible(True)		
		app.reparent(main_window)
		main_window.show_all()
		main_window.hide()
		#tray.show()
		gtk.main()

else:
	pass


logging.debug('4 - Going to load applet')

	
if __name__ == '__main__':
	#os.system('python ')

	
	gnomeapplet.bonobo_factory(
	           "OAFIID:GNOME_GnoMenu_Factory",
	           gnomeapplet.Applet.__gtype__,
	           "GnoMenu",
	           "2",
	           GnoMenu_factory)

